--- old/usr/src/lib/libsysdemangle/common/sysdemangle.c	Tue Feb 27 22:58:09 2018
+++ new/usr/src/lib/libsysdemangle/common/sysdemangle.c	Tue Feb 27 22:58:09 2018
@@ -55,20 +55,18 @@
 	if (lang == SYSDEM_LANG_AUTO) {
 		lang = detect_lang(str);
 		if (lang == SYSDEM_LANG_AUTO) {
-			errno = ENOSYS;
+			errno = ENOTSUP;
 			return (NULL);
 		}
 	}
 
 	switch (lang) {
+	case SYSDEM_LANG_AUTO:
+		break;
 	case SYSDEM_LANG_CPP:
 		return (cpp_demangle(str, ops));
-
-	default:
-		break;
 	}
 
-	/* XXX: better return value? */
-	errno = ENOSYS;
+	errno = ENOTSUP;
 	return (NULL);
 }
